package com.siulkilulki.model;

import com.vaadin.data.Container;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

/**
 * Created by siulkilulki on 10.03.16.
 */
public class Meetings
{
    private List<Meeting> autoSortedMeetings;

    public Meetings()
    {
        this.autoSortedMeetings = new ArrayList<>();
    }

    public Meetings( List<Meeting> meetings )
    {
        this.autoSortedMeetings = (ArrayList) meetings;
    }

    public Meeting getMeetingAt( int index )
    {
        return autoSortedMeetings.get( index );
    }

    public int getSize()
    {
        return autoSortedMeetings.size();
    }

    public void addMeeting( Meeting meeting )
    {
        if( autoSortedMeetings.isEmpty() )
        {
            autoSortedMeetings.add( meeting );
        } else
        {
            autoSortedMeetings.add( getProperInputIndex( meeting ), meeting );
        }

    }

    public void removeMeeting ( Meeting meeting )
    {
        autoSortedMeetings.remove( meeting );
    }

    int getProperInputIndex( Meeting meeting )
    {
        int i = 0;
        while( i < autoSortedMeetings.size() &&
                meeting.getDateStart().getTime() > autoSortedMeetings.get( i ).getDateStart().getTime() )
        {
            i++;
        }
        return i;
    }
}
