package com.siulkilulki.presenters;

import com.siulkilulki.model.Meeting;
import com.siulkilulki.model.Meetings;
import com.siulkilulki.views.MeetingRowView;
import com.siulkilulki.views.MeetingRowViewImpl;
import com.siulkilulki.views.MeetingsView;
import com.siulkilulki.views.MeetingsViewImpl;
import com.vaadin.ui.Button;
import com.vaadin.ui.Calendar;
import com.vaadin.ui.VerticalLayout;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by siulkilulki on 13.03.16.
 */
public class MeetingsPresenter implements MeetingsView.MeetingsViewListener
{
    Meetings model;
    MeetingsViewImpl view;

    public MeetingsPresenter( Meetings model, MeetingsViewImpl view )
    {
        this.model = model;
        this.view = view;

        view.addListener( this );
    }

    public Meetings getModel()
    {
        return model;
    }

    @Override
    public void buttonOnClick( Button.ClickEvent event )
    {
        System.out.println( "im happy" );
        if( event.getButton() == view.getAddButton() )
        {
            System.out.println( "i ve got info" );
            Meeting meeting = new Meeting(
                    view.getTopicName(),
                    view.getMeetingDescription(),
                    view.getDate()
            );
            model.addMeeting( meeting );

            view.setDisplay( generateMeetingsLayout() );

        } else
        {
            System.out.println( "i dont have info" );
        }
    }

    public VerticalLayout generateMeetingsLayout()
    {
        VerticalLayout meetingsLayout = new VerticalLayout();
        for( int i = 0; i < model.getSize(); i++ )
        {
            Meeting meeting = model.getMeetingAt( i );
            SimpleDateFormat dateFormat = new SimpleDateFormat( "dd-M-yyyy" );
            SimpleDateFormat hourFormat = new SimpleDateFormat( "HH:mm" );
            Date date = meeting.getDateStart();
            MeetingRowViewImpl meetingRowView = new MeetingRowViewImpl
                    (
                            meeting.getTopic(),
                            meeting.getDescription(),
                            dateFormat.format( date ),
                            hourFormat.format( date )
                    );

            new MeetingRowPresenter( meeting, meetingRowView, this );
            meetingsLayout.addComponent( meetingRowView );

            //model.getMeetingAt( i );
        }
        return meetingsLayout;
    }
}
