package com.siulkilulki.views;

import com.siulkilulki.model.Meeting;
import com.siulkilulki.model.Meetings;
import com.vaadin.navigator.View;
import com.vaadin.ui.*;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by siulkilulki on 13.03.16.
 */
public class MeetingRowViewImpl extends CustomComponent implements MeetingRowView, Button.ClickListener
{
    private Label startDate;
    private Label startHour;
    private Label title;
    private Label description;
    private Button deleteButton;
    private Button viewButton;

    public MeetingRowViewImpl(String title, String description, String startDate, String startHour)
    {
        HorizontalLayout rowLayout = new HorizontalLayout();
        VerticalLayout verticalLayout = new VerticalLayout();
        VerticalLayout verticalLayout2 = new VerticalLayout();
        VerticalLayout verticalLayout3 = new VerticalLayout();

        this.startDate = new Label( startDate );
        this.startHour = new Label( startHour );
        this.title = new Label(title );
        this.description = new Label( description );
        viewButton = new Button( "View", this );
        deleteButton = new Button( "Delete", this );

        verticalLayout2.addComponents( this.title, this.description );
        verticalLayout3.addComponents( viewButton, deleteButton );
        verticalLayout.addComponents( this.startDate, this.startHour );
        rowLayout.addComponents( verticalLayout, verticalLayout2, verticalLayout3 );
        setCompositionRoot( rowLayout );

        /*deleteButton.addClickListener( (Button.ClickListener) clickEvent -> {
            deleteButton.setCaption( "Clicked" );
            Layout parent = (Layout) this.getParent();
            parent.removeComponent( this );
        } );

        viewButton.addClickListener( clickEvent -> {
            PopUpViewImpl subWindow = new PopUpViewImpl();
            UI.getCurrent().addWindow( subWindow );
        } );*/
    }


    List<MeetingRowView.MeetingRowViewListener> listeners = new ArrayList<>();

    @Override
    public void addListener( MeetingRowViewListener listener )
    {
        listeners.add( listener );
    }

    @Override
    public void buttonClick( Button.ClickEvent clickEvent )
    {
        for( MeetingRowView.MeetingRowViewListener listener : listeners )
        {
            listener.buttonOnRowClick( clickEvent );
        }
    }

    public Button getDeleteButton()
    {
        return deleteButton;
    }

    public Button getViewButton()
    {
        return viewButton;
    }

    @Override
    public void setDisplay( Meeting meeting )
    {

    }
}
