package com.siulkilulki.views;

import com.siulkilulki.model.Meetings;
import com.vaadin.shared.ui.datefield.Resolution;
import com.vaadin.ui.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by siulkilulki on 13.03.16.
 */
public class MeetingsViewImpl extends CustomComponent implements MeetingsView, Button.ClickListener
{
    private Button addButton;
    private TextField topicField;
    private TextField descriptionField;
    private InlineDateField date;

    private HorizontalLayout rootLayout;
    private VerticalLayout meetingsListLayout;

    public String getTopicName()
    {
        return topicField.getValue();
    }

    public String getMeetingDescription()
    {
        return descriptionField.getValue();
    }

    public Date getDate()
    {
        return date.getValue();
    }

    public MeetingsViewImpl()
    {
        rootLayout = new HorizontalLayout();

        VerticalLayout leftPanelLayout = new VerticalLayout();
        leftPanelLayout.setMargin( true );

        topicField = new TextField( "Topic" );
        descriptionField = new TextField( "Description" );
        date = new InlineDateField();
        date.setValue( new Date() );
        date.setResolution( Resolution.MINUTE );
        addButton = new Button( "Add", this );
        leftPanelLayout.addComponents( topicField, descriptionField, date, addButton );

        meetingsListLayout = new VerticalLayout();
        //meetingsListLayout.setImmediate( true );
        rootLayout.addComponents( leftPanelLayout, meetingsListLayout );
        setCompositionRoot( rootLayout );
    }


    List<MeetingsViewListener> listeners = new ArrayList<>();

    @Override
    public void addListener( MeetingsViewListener listener )
    {
        listeners.add( listener );
    }

    public Button getAddButton()
    {
        return addButton;
    }

    @Override
    public void buttonClick( Button.ClickEvent clickEvent )
    {
        for( MeetingsViewListener listener : listeners )
        {
            listener.buttonOnClick( clickEvent );
        }
    }

    @Override
    public void setDisplay( Layout meetingsLayout )
    {
        VerticalLayout layout = (VerticalLayout) meetingsLayout;
        meetingsListLayout.removeAllComponents();
        meetingsListLayout.replaceComponent( layout, layout );
        System.out.println( "display generated" );
    }
}
