package com.siulkilulki.views;

import com.siulkilulki.model.Meeting;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Window;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by siulkilulki on 16.03.16.
 */
public class PopUpViewImpl extends Window implements PopUpView, Button.ClickListener
{
    private Meeting meeting;
    private Button closeButton;
    private Label startDate;
    private Label startHour;
    private Label title;
    private Label description;

    public PopUpViewImpl( String title, String description, String startDate, String startHour  )
    {
        super( "Spotkanie" ); // Set window caption
        center();
        setClosable( true );
        this.setModal( true );
        VerticalLayout content = new VerticalLayout();


        this.startDate = new Label( startDate );
        this.startHour = new Label( startHour );
        this.title = new Label(title );
        this.description = new Label( description );
        closeButton = new Button( "Close", this );

        content.addComponent( closeButton );

        content.setMargin( true );
        setContent( content );
    }

    List<PopUpViewListener> listeners = new ArrayList<>();

    @Override
    public void addListener( PopUpViewListener listener )
    {
        listeners.add( listener );
    }

    @Override
    public void buttonClick( Button.ClickEvent clickEvent )
    {
        for( PopUpViewListener listner : listeners )
        {
            listner.buttononClick( clickEvent );
        }
    }

    public Button getCloseButton()
    {
        return closeButton;
    }
}
